<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class>
      <h1>Roles</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->

      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }">
          <i class="mdi mdi-home-outline"></i>
        </el-breadcrumb-item>
        <el-breadcrumb-item :to="{ path: '/roles' }">Roles</el-breadcrumb-item>
        <el-breadcrumb-item>Add </el-breadcrumb-item>

      </el-breadcrumb>

      <div style="text-align: right; position: relative">
      </div>
    </div>
    <br />
    <el-card
      class="box-card"
      style="text-align: left; margin: 20px 0"
      v-loading="loading"
    >
      <div class="card-header">
      </div>
      <div
        class="form-box"
        style="margin-top: 20px"
        @keyup.enter="save"
      >
        <el-form
          :rules="rules"
          ref="detail"
          :model="detail"
        >
          <el-row :gutter="30">
            <el-col
              :span="24"
              :md="24"
              :sm="24"
              :xs="24"
              class="col-p"
            >
              <el-form-item
                label=" Name"
                prop="name"
              >
                <el-input
                    placeholder="Enter name of role"
                    type="text"
                    v-model="detail.name" />
              </el-form-item>
            </el-col>

          </el-row>
          <el-row :gutter="30">
            <el-col
              :span="24"
              :md="24"
              :sm="24"
              :xs="24"
              class="col-p"
            >
            </el-col>
          </el-row>
          <el-row :gutter="30">
            <el-col
              :span="24"
              :md="24"
              :sm="24"
              :xs="24"
              class="col-p"
            >
              <el-form-item
                label="Description"
                prop="description"
              >
                <el-input
                  placeholder="Enter description"
                  type="text"
                  v-model="detail.description"
                ></el-input>
              </el-form-item>
            </el-col>


          </el-row>
          <el-row :gutter="30">
              <el-col  :span="24"
              :md="24"
              :sm="24"
              :xs="24"
              class="col-p">
                  <div >
            <div class="btn-right ">
              <el-button
                icon="mdi mdi-content-save-outline"
                class="mb-20"
                type="primary"
                @click="save"
                @keyup.enter="save"
              > Save changes</el-button>
            </div>
          </div>
              </el-col>
          </el-row>


        </el-form>
      </div>
    </el-card>

  </div>
</template>

<script>

import { role as roleAPI, } from '~/services/apis/index'
import NotFound from '../ContentNotFound'
export default {
  name: 'AddRole',
  components: {
    NotFound,
  },
  data () {

    return {
      detail: {
        id: '',
        name: '',
        display_name: '',
        description: '',
        created_at: "",
        updated_at: "",
      },
      permissions: [],
      permissionsChecked: [],
      loading: true,
      dialogvisible: false,
      isContentFound: false,


      rules: {
        name: [
          { required: true, message: 'Please input name', trigger: 'blur' },
          { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
        ],
        display_name: [
          { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
        ],
        description: [
          { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
        ],

      },

    }
  },
  methods: {
    getPermissions () {
      this.loading = false;
    },

    save () {
      this.loading = true;
      this.$refs['detail'].validate((valid) => {
        if (valid) {
          this.submit();
        } else {
          this.loading = false;
          return false;
        }
      });

    },
    submit () {

      let data = {
        name: this.detail.name,
        display_name: this.detail.display_name,
        description: this.detail.description,
      };

      roleAPI.addRole(data)
        .then((res) => {
          this.$notify({
            title: "Success",
            message: "Add successfully!",
            type: "success"
          });
          this.loading = false;
         this.$router.push({path: `/roles/${res.data.data.id}/edit`});
        })
        .catch((err) => {
          this.$notify({
            title: "Error",
            message: "Add failed!",
            type: "error"
          });
          this.loading = false;
        })
    }

  },

  mounted () {
    this.getPermissions();

  }
}
</script>

<style lang="scss">

</style>
